import BankAccount;

public class Transfer implements Runnable {
  public static void main(String[] args) {
    Transfer x = new Transfer(new BankAccount(100.0), 
                              new BankAccount(100.0), 
                              50.0);
    Thread t = new Thread(x);
    t.start();
    Thread.yield();  // Force a context switch
    
    System.out.println("Account a has $"+x.a.getBalance());
    System.out.println("Account b has $"+x.b.getBalance());
  }

  public BankAccount a, b;
  public double amount;

  public Transfer(BankAccount a, BankAccount b, double amount) {
    this.a = a;
    this.b = b;
    this.amount = amount;
  }

  public void run() {
    System.out.println("Before transfer a has $"+a.getBalance());
    System.out.println("Before transfer b has $"+b.getBalance());
    a.transfer(amount, b);
    System.out.println("After transfer a has $"+a.getBalance());
    System.out.println("After transfer b has $"+b.getBalance());
  }    
}

